c ----------------      Subroutine V_function     --------------------------
c Calculate azimuthal velocity component eigenfunction for rotating 
c disk.  Called from Linear.f Uses values provided by subroutine
c hvalues.f
c
c     Author: TCC
c
c --------------------------------------------------------------------------

      subroutine vfunction
c***************************************************************************
c Perform 64-bit arithmetic
      IMPLICIT REAL*8 (A-H,O-Y)
      IMPLICIT COMPLEX*16 (Z)

c Number of collocation points JX
      PARAMETER (JX= 46)

c Number of equations and variables
      PARAMETER (NEQU= 2)
      parameter (nvar=nequ, isize=(jx+1)*nequ)

c Highest derivative nx
      PARAMETER (NX= 4)

c Number of constants (or zero)
      PARAMETER (NCON= 0)

c Number of parameters
      PARAMETER (NPAR= 5)

c**************************************************************************

c Input/Output unit number
      PARAMETER (iomodu=90)

      dimension f(jx), g(jx), fmagu(jx), fmagv(jx)
      common /params/ con(0:ncon),par(npar),dpar(npar,2),ipar(npar,2),
     &                itask
      common /collot/ chx(0:jx),chtx(0:jx,0:2*jx+nx+1,0:nx)
     &                         ,chty(0:jx,0:2*jx+nx+1,0:nx)
      common /collof/ chy(0:jx),chfy(0:jx,0:jx,0:nx,1:nvar)
      common /funct/  phys(0:jx,0:nx,1:nvar)
      character*8 conname,parname,varname
      character*80 problem
      complex*16 phys,f,g,det

      rzero=0.
      rone=1.
      re=par(1)
      alpha=par(2)
      beta=par(3)
      za= dcmplx(rone/re,alpha)
      zb= dcmplx(-beta,rzero)
      zc= dcmplx(rzero, beta)
      zd= dcmplx(alpha,rzero)
      det=za*zd-zc*zb
      do 10 j=0,jx
        f(j)=(phys(j,1,1)*zd-phys(j,0,2)*zc)/det
        g(j)=(phys(1,0,2)*za-phys(j,1,1)*zb)/det 
        fmagu(j)=dcabs(f(j))
10      fmagv(j)=dcabs(g(j))
c
      write(iomodu,*) 'Values of radial velocity modulus 
     &                 (Eta,value)'
c
      do 20 i=1,jx
20      write(iomodu,'(1p2e15.7)') chy(j),fmagu(j)
c
      write(iomodu,*) 'Values of azimuthal velocity modulus
     &                 (Eta,value)'
c
      do 30 i=1,jx
30      write(iomodu,'(1p2e15.7)') chy(j),fmagv(j)
c
      close(iomodu)
      return
      end


        
