C **********************************************************************
C
C  SUBROUTINE ZAXPY
C
C **********************************************************************
      SUBROUTINE ZAXPY(N,ZA,ZX,INCX,ZY,INCY)
C
C     CONSTANT TIMES A VECTOR PLUS A VECTOR.
C     JACK DONGARRA, 3/11/78.
C
c Perform 64-bit arithmetic
#ifdef CRAY
#define ZERO 0.0E0
#define D_CABS1 CABS1
#define C_MPLEX complex
C     REAL D_CABS1
#else
#define ZERO 0.0D0
#define D_CABS1 DCABS1
#define C_MPLEX complex*16
C     DOUBLE PRECISION D_CABS1
#endif
      C_MPLEX ZX(N),ZY(N),ZA
C ----------------------------------------------------------------------
C
C  I ELIMINATED  DCABS1  FROM THE CODE BY COMMENTING OUT THE LINES IN
C  WHICH IT APPEARED.   (NOVEMBER 15, 1988.)
C
C ----------------------------------------------------------------------
      IF(N.LE.0)RETURN
C     IF (D_CABS1(ZA) .EQ. ZERO) RETURN
C ----------------------------------------------------------------------
C
C  THE FOLLOWING LINE IS USED AS A SUBSTITUTE FOR THE PRECEEDING LINE
C  INVOLVING  DCABS1.
C
C ----------------------------------------------------------------------
      IF( ZA .EQ. (ZERO,ZERO) ) RETURN
      IF (INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        ZY(IY) = ZY(IY) + ZA*ZX(IX)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
   20 DO 30 I = 1,N
        ZY(I) = ZY(I) + ZA*ZX(I)
   30 CONTINUE
      RETURN
      END
