c ------ Subroutine H_CURVE --------------------------------------------
c Trace eigensolutions along a curve in a plane (neutral curve ...)
c
c     Author: Thorwald Herbert, OSU, 1989
c
c ----------------------------------------------------------------------

      subroutine hcurve(idev,indt)
#include "common.ins"
      common /params/ con(0:ncon),par(npar),dpar(npar),ipar(npar),
     |                itask
      common /names/  conname(0:ncon),parname(npar),varname(nvar),
     |                problem
      character*8 conname,parname,varname
      character*80 problem
      common /vcurve/ vini(3),vcon(3),veps(2),vgrid(2)
      common /scurve/ cavg,crad,cang
      dimension iv(3),vmin(2),vmax(2)
      data no/0/,npoints/0/

      do 1 i=1,2
         read (iopars,*) iv(i),vgrid(i),vmin(i),vmax(i)
         if (iv(i).lt.1.or.iv(i).gt.npar) then
            print*,'H_CURVE: Improper choice of parameter',iv(i)
            stop
         endif
         if (vgrid(i).le.0) then
            print*,'H_CURVE: Improper choice of scales'
            stop
         endif
         if (vmin(i).ge.vmax(i)) then
            print*,'H_CURVE: Improper choice of range'
            stop
         endif
         vini(i)=par(iv(i))
         vcon(i)=0
         veps(i)=0
1     continue
      if (iv(1).eq.iv(2)) then
         print*,'H_CURVE: Improper choice of identical parameters'
         stop
      endif

      read (iopars,*) angle,radius
      read (iopars,*) npoints

c *** main loop

      write(iologi,*)
      write(iologi,*)itask,' /task: curve'
      write(iologi,'(i2,1p3e12.4,30h /X-parameter, scale, min, max)')
     |     iv(1),vgrid(1),vmin(1),vmax(1)
      write(iologi,'(i2,1p3e12.4,30h /Y-parameter, scale, min, max)')
     |     iv(2),vgrid(2),vmin(2),vmax(2)
      write(iologi,'(1p2e11.4,15h /angle, radius)')angle,radius
      write(iologi,'(i22,17h /number of steps)')npoints

      print*
      print*,'Curve in the Plane x= ',parname(iv(1))
      print*,'                   y= ',parname(iv(2))
      print 2000,(parname(m),m=1,npar)
2000  format (/8(4x,a8,3x))
      open(iocurv,file='O.curve',status='unknown')
      rewind(iocurv)
      write(iocurv,*)'Curve in the Plane x= ',parname(iv(1))
      write(iocurv,*)'                   y= ',parname(iv(2))
      write(iocurv,2000)(parname(m),m=1,npar)
      write(iologo,*)
      write(iologo,*)'Curve in the Plane x= ',parname(iv(1))
      write(iologo,*)'                   y= ',parname(iv(2))
      write(iologo,2000)(parname(m),m=1,npar)
      no=-1

5     call nextpt(no,iter,radius,angle,dist)
      do 2 i=1,npar
         dpar(i)=0
2     continue
      par(iv(1))=vini(1)
      par(iv(2))=vini(2)
      dpar(iv(1))=veps(1)*vgrid(1)
      dpar(iv(2))=veps(2)*vgrid(2)

      call hlocal(idev,indt,iter)

      vcon(1)=par(iv(1))
      vcon(2)=par(iv(2))
      print 2001,(par(m),m=1,npar)
2001  format (1p8e15.7)
      write(iocurv,2001)(par(m),m=1,npar)
      write(iologo,2001)(par(m),m=1,npar)

      if (no.ge.npoints.or.dist.lt.1.or.
     |   vcon(1).lt.vmin(1).or.vcon(1).gt.vmax(1).or.
     |   vcon(2).lt.vmin(2).or.vcon(2).gt.vmax(2)) then
         iavg=100*cavg
         print 2002, crad,cang,iavg
2002     format (/' Current radius=',1pe10.3,' angle=',0pf6.1,
     |          ' (avg.=',i4,'%)')
         write(iologo,2002) crad,cang,iavg
         close(iocurv)
         return
      endif
      go to 5
      end
