# -------------------------------------------
# For APOLLO, IRIS, and SUN, uncomment the following lines
# and set the proper -D in CPFLAGS
CPP    = /lib/cpp
CPFLAGS= -P -I$(VPATH) -DAPOLLO
FF     = f77
FFFLAGS= -c -w -O
LD     = f77
LDFLAGS=
LIB    = -L../w.lib -lut
# -------------------------------------------
# For the Cray, uncomment the following lines
# CPP    = /lib/cpp
# CPFLAGS= -P -I$(VPATH) -DCRAY
# FF     = ncft77
# FFFLAGS= -m 4
# LD     = segldr
# LDFLAGS=
# LIB    = -l../w.lib/libut.a
# -------------------------------------------
CODE   = w.code
LIBES  = ../w.lib/libut.a

.f.o :
	$(CPP) $(CPFLAGS) $< >$(CODE)/$<
	$(FF) $(FFFLAGS) $(CODE)/$<

LINEAR = linear.o chinit.o chxtoy.o chttof.o bstate.o \
         hglobal.o pvector.o qvector.o hlocal.o \
         hvalues.o htable.o hcurve.o nextpt.o

linear.x : $(LINEAR)
	$(LD) -o $(VPATH)/linear.x $(LINEAR) $(LIB)

# --- Dependencies ---
$(LINEAR) : $(LIBES) $(CODE) common.ins Makefile
bstate.o  : bstate.ins
pvector.o : vector.ins
qvector.o : vector.ins

$(LIBES):
	cd ../w.lib; make
$(CODE) :
	mkdir $(CODE)
clean:
	-/bin/rm -r $(CODE)
	-/bin/rm *.o
	-rm -i $(VPATH)/linear.x
