c ------ Subroutine Q_VECTOR -------------------------------------------
c Set the coefficient matrix Q at collocation points
c
c     Author: Thorwald Herbert, OSU, 1988
c
c ----------------------------------------------------------------------

      subroutine qvector
#include "common.ins"
      common /collof/ chy(0:jx),chfy(0:jx,0:jx,0:nx,1:nvar)
      common /vector/ pvec(0:jx,1:nequ,0:nx,1:nvar,0:npar),
     |                rvec(0:jx,1:nequ,0:nx,1:nvar)
      common /params/ con(0:ncon),par(npar),dpar(npar),ipar(npar),
     |                itask
      common /names/  conname(0:ncon),parname(npar),varname(nvar),
     |                problem
      character*8 conname,parname,varname
      character*80 problem

c reset coefficient matrix to zero

      do 1 j=0,jx
        do 1 i=1,nequ
           do 1 n=0,nx
              do 1 l=1,nvar
                 rvec(j,i,n,l)=0
                 do 1 m=1,npar
                    pvec(j,i,n,l,m)=0
1     continue

c set coefficient matrix at collocation points

      ideriv=1
      do 2 j=0,jx

c **********************************************************************
#include "vector.ins"
c **********************************************************************

2     continue

      do 3 m=1,npar
      if (dpar(m).ne.0) then
         pvecx=0
         do 4 j=0,jx
           do 4 i=1,nequ
              do 4 n=0,nx
                 do 4 l=1,nvar
                    rvec(j,i,n,l)=rvec(j,i,n,l)+dpar(m)*pvec(j,i,n,l,m)
                    pvecx=max(pvecx,abs(pvec(j,i,n,l,m)))
4        continue
         if (pvecx.eq.0) then
            print 1000, parname(m)
1000        format ('Q_VECTOR: Derivative wrto ',a8,' is zero.')
            stop
         endif
      endif
3     continue
      return
      end
